## approx 1.15

=== Makefile ===
# approx: proxy server for Debian archive files
# Copyright (C) 2005  Eric C. Cooper <ecc@cmu.edu>
# Released under the GNU General Public License

export OCAMLMAKEFILE = /usr/share/ocaml-tools/OCamlMakefile

export OCAMLFLAGS = -w A

define PROJ_server
    SOURCES = util.ml config.ml default_config.ml url.ml approx.ml
    LIBS = unix pcre syslog netstring http curl
    INCDIRS = +pcre +syslog +netstring +http +curl
    RESULT = approx
endef
export PROJ_server

define PROJ_gc
    SOURCES = util.ml config.ml default_config.ml package.ml gc_approx.ml
    LIBS = unix pcre
    INCDIRS = +pcre
    RESULT = gc_approx
endef
export PROJ_gc

ifndef SUBPROJS
    export SUBPROJS = server gc
endif

all: native-code

%:
	@$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=$@

=== debian/changelog ===
approx (1.15) unstable; urgency=low

  * Build byte-code version on architectures with no ocamlopt
  * Create /var/cache/approx directory in postinst script

 -- Eric Cooper <ecc@cmu.edu>  Sat,  7 May 2005 11:08:38 -0400

approx (1.14) unstable; urgency=low

  * Added --foreground option to approx (closes: #306898)

 -- Eric Cooper <ecc@cmu.edu>  Thu,  5 May 2005 10:43:36 -0400

approx (1.13) unstable; urgency=low

  * Make sure /var/cache/approx exists before trying to chown it
    (closes: #306621)
  * No longer allow the cache directory to be specified in approx.conf;
    always use /var/cache/approx (which can be a symlink)

 -- Eric Cooper <ecc@cmu.edu>  Wed, 27 Apr 2005 18:39:13 -0400

approx (1.12) unstable; urgency=low

  * New description, from suggestions by
    Raphaël Berbain <raphael.berbain@free.fr>
  * approx
    - run as unprivileged user (closes: #305451)
    - added /etc/default/approx with example of setting
      http_proxy environment variable (closes: #305453)
    - detect possible conflict with apt-proxy at installation time
      and at runtime if binding to port 9999 fails
  * gc_approx
    - remove unused distributions and empty parent directories from cache
    - don't recheck files that have already been checked
    - uncompress Packages.gz files to disk
    - use wget to download Packages.gz file if decompression fails

 -- Eric Cooper <ecc@cmu.edu>  Mon, 25 Apr 2005 09:01:56 -0400

approx (1.11) unstable; urgency=low

  * Daemonize correctly (closes: #305102)

 -- Eric Cooper <ecc@cmu.edu>  Sun, 17 Apr 2005 19:57:56 -0400

approx (1.10) unstable; urgency=low

  * Bumped dependency on syslog-ocaml (closes: #305019)

 -- Eric Cooper <ecc@cmu.edu>  Sun, 17 Apr 2005 12:47:12 -0400

approx (1.09) unstable; urgency=low

  * rebuilt against ocamlnet 1.0 and ocaml-http 0.1.0-3
  * debian/control
    - added me as an uploader
    - bumped dependencies on ocamlnet and ocaml-http

 -- Stefano Zacchiroli <zack@debian.org>  Sat, 16 Apr 2005 10:13:30 +0200

approx (1.08) unstable; urgency=low

  * Removed trunk directory layer
  * Add build-dependency on ocaml-tools (closes: #303774)

 -- Eric Cooper <ecc@cmu.edu>  Fri,  8 Apr 2005 14:57:43 -0400

approx (1.07) unstable; urgency=low

  * Eliminate timeout for approx daemon callbacks
  * Make gc_approx handle "Filename: ./foo" correctly
  * Turn on all OCaml compiler warnings and clean up code
  * Sven Luther :
    - Preparing upload built with ocaml 3.08.3.
    - Taking over maintainership of this package, since Eric is not a DD.
    - Tested on my home setup since the past three weeks.

 -- Eric Cooper <ecc@cmu.edu>  Sat, 12 Mar 2005 17:27:43 -0500

approx (1.06) unstable; urgency=low

  * Use native syslog client instead of piping output to logger
  * Use open_process_in and gzip instead of camlzip to uncompress
    package files in gc_approx
  * gc_approx removes garbage files unless --keep option is specified
  * APPROX_CONF environment variable no longer used;
    pathname is now hard-coded in default_config.ml
  * Write /var/run/approx.pid for use by init script

 -- Eric Cooper <ecc@cmu.edu>  Thu, 24 Feb 2005 13:36:26 -0500

approx (1.05) unstable; urgency=low

  * Use proper content type and encoding when relaying *.gz files
  * Log client IP address
  * Install into /usr/sbin
  * Add init.d and cron scripts
  * Double fork to detach daemon
  * Use distribution names from the config file as roots for GC,
    to detect remote repositories no longer in use

 -- Eric Cooper <ecc@cmu.edu>  Wed, 23 Feb 2005 23:59:35 -0500

approx (1.04) unstable; urgency=low

  * Add build-dependency on the version of ocamlnet
    which fixes a problem with '+' characters in URLs
  * Append ".tmp" to download in progress and rename it when complete,
    to avoid invalid files in the cache if the daemon is interrupted

 -- Eric Cooper <ecc@cmu.edu>  Sun,  6 Feb 2005 17:20:18 -0500

approx (1.03) unstable; urgency=low

  * Cleanup libcurl connection after each transfer

 -- Eric Cooper <ecc@cmu.edu>  Fri,  4 Feb 2005 09:05:00 -0500

approx (1.02) unstable; urgency=low

  * Use libcurl-ocaml instead of my own wrapper

 -- Eric Cooper <ecc@cmu.edu>  Thu,  3 Feb 2005 21:42:36 -0500

approx (1.01) unstable; urgency=low

  * Don't garbage collect only .deb files;
    consider everything except Packages, Release, and Sources files

 -- Eric Cooper <ecc@cmu.edu>  Tue,  1 Feb 2005 15:52:02 -0500

approx (1.00) unstable; urgency=low

  * Initial release

 -- Eric Cooper <ecc@cmu.edu>  Sun, 23 Jan 2005 14:05:29 -0500

=== debian/control ===
Source: approx
Section: admin
Priority: optional
Maintainer: Eric Cooper <ecc@cmu.edu>
Uploaders: Sven Luther <luther@debian.org>, Stefano Zacchiroli <zack@debian.org>
Build-Depends: debhelper (>= 4), ocaml-nox-3.08.3, ocaml-tools, libsyslog-ocaml-dev (>= 1.0-3), libhttp-ocaml-dev (>= 0.1.0-3), libocamlnet-ocaml-dev (>= 1.0), libpcre-ocaml-dev, libcurl-ocaml-dev
Standards-Version: 3.6.1

Package: approx
Architecture: any
Depends: ${shlibs:Depends}, wget
Description: caching proxy server for Debian archive files
 Approx is an HTTP-based Debian archive server.
 It fetches packages from remote repositories on demand,
 and caches them for local use.
 .
 Approx saves time and network bandwidth if you need to install or
 upgrade Debian software for a number of machines on a local network.
 Each package is downloaded from a remote site only once,
 regardless of how many local clients install it.
 The approx cache typically requires a few gigabytes of disk space.
 .
 Approx also simplifies the administration of client machines:
 repository locations need only be changed in approx's configuration file,
 not in every client's /etc/apt/sources.list file.
 .
 Approx can be used as a replacement for apt-proxy,
 with no need to modify clients' /etc/apt/sources.list files,
 or as an alternative to apt-cacher, with no need to run Apache.
 .
 Approx is intended to be robust, simple, and efficient.
 It is written in OCaml (Objective Caml).

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

build: build-stamp
build-stamp:
	dh_testdir
	if [ -x /usr/bin/ocamlopt ]; then \
	    $(MAKE) native-code; \
	else \
	    $(MAKE) byte-code; \
	fi
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	-$(MAKE) clean
	dh_clean

DESTDIR = $(CURDIR)/debian/tmp/usr/bin

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	dh_install approx gc_approx usr/sbin
	dh_install approx.conf etc/approx

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installcatalogs
#	dh_installpam
#	dh_installmime
	dh_installinit
	dh_installcron
#	dh_installinfo
#	dh_undocumented
	dh_installman *.[1-8]
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

# -*- makefile-mode -*-

## approx 2.03

=== Makefile ===
# approx: proxy server for Debian archive files
# Copyright (C) 2005  Eric C. Cooper <ecc@cmu.edu>
# Released under the GNU General Public License

export OCAMLMAKEFILE = /usr/share/ocaml-tools/OCamlMakefile

export OCAMLFLAGS = -w A

define PROJ_server
    SOURCES = util.ml config.ml default_config.ml log.ml url.ml control_file.ml release.ml server.ml version.ml approx.ml
    INCDIRS = +pcre +syslog +netstring +cgi +nethttpd
    LIBS = unix pcre syslog netstring cgi nethttpd
    RESULT = approx
endef
export PROJ_server

define PROJ_gc
    SOURCES = util.ml config.ml default_config.ml control_file.ml gc_approx.ml
    INCDIRS = +pcre
    LIBS = unix pcre
    RESULT = gc_approx
endef
export PROJ_gc

define PROJ_fsck
    SOURCES = util.ml config.ml default_config.ml control_file.ml release.ml fsck_approx.ml
    INCDIRS = +pcre
    LIBS = unix pcre
    RESULT = fsck_approx
endef
export PROJ_fsck

ifndef SUBPROJS
    export SUBPROJS = server gc fsck
endif

all: native-code

%:
	@$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=$@

=== debian/changelog ===
approx (2.03) unstable; urgency=low

  * Fixed cron script (closes: #343105)
  * Updated debian/compat to 5

 -- Eric Cooper <ecc@cmu.edu>  Mon, 12 Dec 2005 15:43:46 -0500

approx (2.02) unstable; urgency=low

  * Make sure all data that is streamed to the client during download
    gets flushed afterwards using cgi#output#commit_work
  * Added debian/control.in and a rule to generate debian/control from it
  * Added conditional dependency on OCaml bytecode interpreter
    for architectures without native compilation

 -- Eric Cooper <ecc@cmu.edu>  Sun, 20 Nov 2005 12:20:58 -0500

approx (2.01) unstable; urgency=low

  * Updated debian/control for ocaml version 3.09.0
  * Added dependency on adduser (for postinst script)
  * Removed unused variables (or renamed with _) to eliminate warnings

 -- Eric Cooper <ecc@cmu.edu>  Tue,  1 Nov 2005 17:43:55 -0500

approx (2.00) unstable; urgency=low

  * Stream the response to the client while downloading to the cache
  * Release with new major version

 -- Eric Cooper <ecc@cmu.edu>  Mon, 10 Oct 2005 10:04:09 -0400

approx (1.51) unstable; urgency=low

  * Changed client to use curl subprocesses instead of ocurl
  * For simplicity, all downloads are cached first, then sent to the client

 -- Eric Cooper <ecc@cmu.edu>  Wed, 14 Sep 2005 09:37:54 -0400

approx (1.50) unstable; urgency=low

  * Changed server to use nethttpd instead of ocaml-http

 -- Eric Cooper <ecc@cmu.edu>  Mon, 22 Aug 2005 16:53:22 -0400

approx (1.18) unstable; urgency=low

  * Secure APT imposes additional consistency requirements on the cache:
    - Release and Release.gpg files must agree
    - Packages and Sources files must agree with the Release file
      that mentions them
  * Closes: #322847

 -- Eric Cooper <ecc@cmu.edu>  Sun, 31 Jul 2005 16:10:13 -0400

approx (1.17) unstable; urgency=low

  * Incorporate patch by Flavio Stanchina <flavio@stanchina.net>
    to recognize Release.gpg and *.bz2 files in gc_approx (closes: #313188)
  * Include Last-Modified header in local responses
  * Support If-Modified-Since for FTP requests using MDTM

 -- Eric Cooper <ecc@cmu.edu>  Fri, 15 Jul 2005 15:34:21 -0400

approx (1.16) unstable; urgency=low

  * Support concurrent requests
    - use http_daemon's Fork mode
    - rely on atomic rename of foo.tmp -> foo in cache
    - detect concurrent downloads in progress and wait for them
  * Differentiate levels of syslog messages

 -- Eric Cooper <ecc@cmu.edu>  Fri, 13 May 2005 12:23:37 -0400

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Eric Cooper <ecc@cmu.edu>
 Uploaders: Sven Luther <luther@debian.org>, Stefano Zacchiroli <zack@debian.org>
-Build-Depends: debhelper (>= 4), ocaml-nox-3.08.3, ocaml-tools, libsyslog-ocaml-dev (>= 1.0-3), libhttp-ocaml-dev (>= 0.1.0-3), libocamlnet-ocaml-dev (>= 1.0), libpcre-ocaml-dev, libcurl-ocaml-dev
-Standards-Version: 3.6.1
+Build-Depends: debhelper (>= 5.0), ocaml-nox (>= 3.09.0), ocaml-best-compilers, ocaml-tools, libocamlnet-ocaml-dev (>= 1.1), libpcre-ocaml-dev (>= 5.10), libsyslog-ocaml-dev (>= 1.2)
+Standards-Version: 3.6.2
 
 Package: approx
 Architecture: any
-Depends: ${shlibs:Depends}, wget
+Depends: ${shlibs:Depends}, ${F:OCamlRuntime}, adduser, bzip2, curl
 Description: caching proxy server for Debian archive files
  Approx is an HTTP-based Debian archive server.
  It fetches packages from remote repositories on demand,
@@ -26,7 +26,7 @@
  .
  Approx can be used as a replacement for apt-proxy,
  with no need to modify clients' /etc/apt/sources.list files,
- or as an alternative to apt-cacher, with no need to run Apache.
+ or as an alternative to apt-cacher.
  .
  Approx is intended to be robust, simple, and efficient.
  It is written in OCaml (Objective Caml).

=== debian/rules ===
#!/usr/bin/make -f

OCAMLABI = $(shell ocamlc -version)
BYTECODE = $(shell [ -x /usr/bin/ocamlopt ] || echo yes)
RUNTIME = $(if $(BYTECODE),ocaml-base-nox-$(OCAMLABI))

debian/control:
	sed -e 's/@OCamlABI@/$(OCAMLABI)/g' $@.in > $@

build: build-stamp
build-stamp:
	dh_testdir
	./gen_version > version.ml
	$(MAKE) $(if $(BYTECODE),byte-code,native-code)
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	-$(MAKE) clean
	dh_clean version.ml

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	dh_install approx gc_approx usr/sbin
	dh_install etc/approx.conf etc/approx

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs doc/README.concurrency
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installcatalogs
#	dh_installpam
#	dh_installmime
	dh_installinit
	dh_installcron
#	dh_installinfo
#	dh_undocumented
	dh_installman doc/*.[1-8]
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol -- -VF:OCamlRuntime="$(RUNTIME)"
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

# -*- makefile-mode -*-

## approx 2.05bpo1

=== Makefile ===
--- 
+++ 
@@ -4,10 +4,10 @@
 
 export OCAMLMAKEFILE = /usr/share/ocaml-tools/OCamlMakefile
 
-export OCAMLFLAGS = -w A
+export OCAMLFLAGS = -warn-error A
 
 define PROJ_server
-    SOURCES = util.ml config.ml default_config.ml log.ml url.ml control_file.ml release.ml server.ml version.ml approx.ml
+    SOURCES = util.ml config.ml default_config.ml log.ml url.ml control_file.ml release.ml ifaddr.c netif.mli server.ml version.ml approx.ml
     INCDIRS = +pcre +syslog +netstring +cgi +nethttpd
     LIBS = unix pcre syslog netstring cgi nethttpd
     RESULT = approx

=== debian/changelog ===
approx (2.05bpo1) sarge-backports; urgency=low

  * Backport to sarge:
    + [debian/control.in]
      - lower version requirement of build-dependency on libpcre-ocaml-dev,
        since it works fine with the version in sarge.
      - ditto for debhelper, and set debian/compat to 4.
    + [debian/control]
      - regenerate from debian/control.in so that the version requirement of
        the ocaml-nox Build-Dependency matchs sarge's ocaml ABI.

 -- Adeodato Simó <dato@net.com.org.es>  Tue, 20 Jun 2006 16:36:22 +0200

approx (2.06) unstable; urgency=low

  * Added "interface" configuration variable to allow listening only
    on a specific network interface, as requested by Romain Lenglet
    <rlenglet@users.forge.objectweb.org> (closes: #352025)
  * Added simple-minded support for file URIs, using the same logic as FTP
  * The server is now started as root by the init script, and then drops
    privileges to user approx after binding its socket. This allows approx
    to listen on port 80, as requested by Andreas John <aj@net-lab.net>

 -- Eric Cooper <ecc@cmu.edu>  Mon, 24 Apr 2006 16:09:22 -0400

approx (2.05) unstable; urgency=low

  * Factor out all uses of curl command (missed one in previous fix)
  * Transition to OCaml 3.09.1

 -- Eric Cooper <ecc@cmu.edu>  Sun,  8 Jan 2006 14:29:20 -0500

approx (2.04) unstable; urgency=low

  * Added --location option to curl so that it will follow HTTP redirections
    (closes: #346082)

 -- Eric Cooper <ecc@cmu.edu>  Thu,  5 Jan 2006 13:56:03 -0500

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Eric Cooper <ecc@cmu.edu>
 Uploaders: Sven Luther <luther@debian.org>, Stefano Zacchiroli <zack@debian.org>
-Build-Depends: debhelper (>= 5.0), ocaml-nox (>= 3.09.0), ocaml-best-compilers, ocaml-tools, libocamlnet-ocaml-dev (>= 1.1), libpcre-ocaml-dev (>= 5.10), libsyslog-ocaml-dev (>= 1.2)
+Build-Depends: debhelper (>= 4.2), ocaml-nox (>= 3.08.3), ocaml-best-compilers, ocaml-tools, libocamlnet-ocaml-dev (>= 1.1), libpcre-ocaml-dev (>= 5.08), libsyslog-ocaml-dev (>= 1.2)
 Standards-Version: 3.6.2
 
 Package: approx
 Architecture: any
-Depends: ${shlibs:Depends}, ${F:OCamlRuntime}, adduser, bzip2, curl
+Depends: ${shlibs:Depends}, ${F:OCamlRun}, adduser, bzip2, curl
 Description: caching proxy server for Debian archive files
  Approx is an HTTP-based Debian archive server.
  It fetches packages from remote repositories on demand,

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 OCAMLABI = $(shell ocamlc -version)
 BYTECODE = $(shell [ -x /usr/bin/ocamlopt ] || echo yes)
-RUNTIME = $(if $(BYTECODE),ocaml-base-nox-$(OCAMLABI))
+OCAMLRUN = $(if $(BYTECODE),ocaml-base-nox-$(OCAMLABI))
 
 debian/control:
 	sed -e 's/@OCamlABI@/$(OCAMLABI)/g' $@.in > $@
@@ -59,7 +59,7 @@
 #	dh_makeshlibs
 	dh_installdeb
 	dh_shlibdeps
-	dh_gencontrol -- -VF:OCamlRuntime="$(RUNTIME)"
+	dh_gencontrol -- -VF:OCamlRun="$(OCAMLRUN)"
 	dh_md5sums
 	dh_builddeb

## approx 2.06

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Eric Cooper <ecc@cmu.edu>
 Uploaders: Sven Luther <luther@debian.org>, Stefano Zacchiroli <zack@debian.org>
-Build-Depends: debhelper (>= 4.2), ocaml-nox (>= 3.08.3), ocaml-best-compilers, ocaml-tools, libocamlnet-ocaml-dev (>= 1.1), libpcre-ocaml-dev (>= 5.08), libsyslog-ocaml-dev (>= 1.2)
+Build-Depends: debhelper (>= 5.0), ocaml-nox (>= 3.09.1), ocaml-best-compilers, ocaml-tools, libocamlnet-ocaml-dev (>= 1.1), libpcre-ocaml-dev (>= 5.10), libsyslog-ocaml-dev (>= 1.2)
 Standards-Version: 3.6.2
 
 Package: approx

## approx 2.8.0

=== Makefile ===
# approx: proxy server for Debian archive files
# Copyright (C) 2006  Eric C. Cooper <ecc@cmu.edu>
# Released under the GNU General Public License

export OCAMLMAKEFILE = /usr/share/ocaml-tools/OCamlMakefile

export OCAMLFLAGS = -warn-error A

define PROJ_server
    SOURCES = util.ml config.ml default_config.ml log.ml url.ml control_file.ml release.ml ifaddr.c internet.mli server.ml version.ml approx.ml
    INCDIRS = +pcre +syslog +netstring +cgi +nethttpd +sha
    LIBS = unix pcre syslog netstring cgi nethttpd sha
    RESULT = approx
endef
export PROJ_server

define PROJ_gc
    SOURCES = util.ml config.ml default_config.ml control_file.ml gc.ml
    INCDIRS = +pcre +sha
    LIBS = unix pcre sha
    RESULT = gc_approx
endef
export PROJ_gc

define PROJ_fsck
    SOURCES = util.ml config.ml default_config.ml control_file.ml release.ml fsck.ml
    INCDIRS = +pcre +sha
    LIBS = unix pcre sha
    RESULT = fsck_approx
endef
export PROJ_fsck

ifndef SUBPROJS
    export SUBPROJS = server gc fsck
endif

all: native-code

%:
	@$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=$@

=== debian/changelog ===
approx (2.8.0) unstable; urgency=low

  * Make sure syslog messages are newline-terminated for syslog-ng
    (closes: #394925)
  * Handle tabs as well as spaces in control files (closes: #394062)
  * Added "max_rate" configuration variable (closes: #392802)
  * Improved description in approx man page of how repository mapping works
  * Added XS-Vcs-Svn header to debian/control file

 -- Eric Cooper <ecc@cmu.edu>  Mon, 23 Oct 2006 22:15:34 -0400

approx (2.7.0) unstable; urgency=low

  * New version numbering with third component for packaging-only changes
  * Deny DiffIndex requests, forcing download of full index files
    (closes: #367475)
  * Keep live source packages (those listed in Sources files)
    (closes: #374736)
  * Decode request URLs to handle '~' in pathnames (closes: #390121)
  * Validate packages with SHA256, otherwise SHA1, otherwise MD5
  * Added --fail option to curl to handle errors better
  * Made init script LSB-compliant and added dependency on lsb-base

 -- Eric Cooper <ecc@cmu.edu>  Mon, 11 Sep 2006 13:09:11 -0400

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,13 @@
 Priority: optional
 Maintainer: Eric Cooper <ecc@cmu.edu>
 Uploaders: Sven Luther <luther@debian.org>, Stefano Zacchiroli <zack@debian.org>
-Build-Depends: debhelper (>= 5.0), ocaml-nox (>= 3.09.1), ocaml-best-compilers, ocaml-tools, libocamlnet-ocaml-dev (>= 1.1), libpcre-ocaml-dev (>= 5.10), libsyslog-ocaml-dev (>= 1.2)
-Standards-Version: 3.6.2
+Build-Depends: debhelper (>= 5.0), ocaml-nox (>= 3.09), ocaml-best-compilers, ocaml-tools, libocamlnet-ocaml-dev (>= 1.1), libpcre-ocaml-dev (>= 5.11), libsyslog-ocaml-dev (>= 1.3), libsha-ocaml-dev (>= 1.3)
+Standards-Version: 3.7.2
+XS-Vcs-Svn: svn://svn.debian.org/svn/pkg-ocaml-maint/trunk/projects/approx
 
 Package: approx
 Architecture: any
-Depends: ${shlibs:Depends}, ${F:OCamlRun}, adduser, bzip2, curl
+Depends: ${shlibs:Depends}, ${F:OCamlRun}, lsb-base (>= 3.1), adduser, bzip2, curl
 Description: caching proxy server for Debian archive files
  Approx is an HTTP-based Debian archive server.
  It fetches packages from remote repositories on demand,

=== debian/rules ===
--- 
+++ 
@@ -3,9 +3,6 @@
 OCAMLABI = $(shell ocamlc -version)
 BYTECODE = $(shell [ -x /usr/bin/ocamlopt ] || echo yes)
 OCAMLRUN = $(if $(BYTECODE),ocaml-base-nox-$(OCAMLABI))
-
-debian/control:
-	sed -e 's/@OCamlABI@/$(OCAMLABI)/g' $@.in > $@
 
 build: build-stamp
 build-stamp:
@@ -65,5 +62,3 @@
 
 binary: binary-indep binary-arch
 .PHONY: build clean binary-indep binary-arch binary install
-
-# -*- makefile-mode -*-

## approx 2.9.0

=== Makefile ===
# approx: proxy server for Debian archive files
# Copyright (C) 2007  Eric C. Cooper <ecc@cmu.edu>
# Released under the GNU General Public License

export OCAMLMAKEFILE = /usr/share/ocamlmakefile/OCamlMakefile

export OCAMLFLAGS = -warn-error A

define PROJ_server
    SIDE_EFFECT = $(shell ./mkversion > version.ml)
    SOURCES = util.ml config.ml default_config.ml log.ml url.ml control_file.ml release.ml ifaddr.c internet.mli version.ml server.ml approx.ml
    INCDIRS = +pcre +syslog +netsys +netstring +netcgi1 +nethttpd-for-netcgi1 +sha
    LIBS = unix pcre syslog netsys netstring cgi nethttpd-for-netcgi1 sha
# use this after the next release of ocamlnet2
# (a bug in the current release prevents this from working)
#    INCDIRS = +pcre +syslog +netsys +netstring +netcgi2 +nethttpd-for-netcgi2 +sha
#    LIBS = unix pcre syslog netsys netstring netcgi nethttpd-for-netcgi2 sha
    RESULT = approx
endef
export PROJ_server

define PROJ_gc
    SOURCES = util.ml config.ml default_config.ml control_file.ml gc.ml
    INCDIRS = +pcre +sha
    LIBS = unix pcre sha
    RESULT = gc_approx
endef
export PROJ_gc

ifndef SUBPROJS
    export SUBPROJS = server gc
endif

all: native-code

export TRASH = version.ml

%:
	@$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=$@

=== debian/changelog ===
approx (2.9.0) unstable; urgency=low

  * Changed debian/rules to use cdbs
  * Improve postinst check for conflict with apt-proxy
    (closes: #395375)
  * Make sure cronjob doesn't fail if approx has been removed
    or cache directory is empty (closes: #404819, #416361)
  * Require configuration parameters to begin with '$' to distinguish
    them from repository names
  * Added $verbose parameter to control logging of informational messages
    (closes: #403514)
  * Added $syslog parameter to specify the syslog facility
    (closes: #406504)
  * Added $user and $group parameters to control the approx daemon's user
    and group [Alexandra N. Kossovsky <sasha@oktetlabs.ru>]
    (closes: #423836)
  * Don't assume deluser is still available in postrm (closes: #416643)
  * Migrated to Ocamlnet 2 (closes: #420478)
  * Changed dependency from ocaml-tools to ocamlmakefile (closes: #428723)

 -- Eric Cooper <ecc@cmu.edu>  Wed, 13 Jun 2007 16:04:53 -0400

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: admin
 Priority: optional
 Maintainer: Eric Cooper <ecc@cmu.edu>
-Uploaders: Sven Luther <luther@debian.org>, Stefano Zacchiroli <zack@debian.org>
-Build-Depends: debhelper (>= 5.0), ocaml-nox (>= 3.09), ocaml-best-compilers, ocaml-tools, libocamlnet-ocaml-dev (>= 1.1), libpcre-ocaml-dev (>= 5.11), libsyslog-ocaml-dev (>= 1.3), libsha-ocaml-dev (>= 1.3)
+Uploaders: Sylvain Le Gall <gildor@debian.org>
+Build-Depends: debhelper (>= 5.0), cdbs, ocamlmakefile, ocaml-nox (>= 3.09), ocaml-best-compilers, libnethttpd-ocaml-dev (>= 2.2), libpcre-ocaml-dev (>= 5.11), libsha-ocaml-dev (>= 1.3), libsyslog-ocaml-dev (>= 1.3)
 Standards-Version: 3.7.2
 XS-Vcs-Svn: svn://svn.debian.org/svn/pkg-ocaml-maint/trunk/projects/approx
 
@@ -31,3 +31,5 @@
  .
  Approx is intended to be robust, simple, and efficient.
  It is written in OCaml (Objective Caml).
+ .
+  Homepage: http://svn.debian.org/wsvn/pkg-ocaml-maint/trunk/projects/approx/

## approx 3.0.0

=== Makefile ===
# approx: proxy server for Debian archive files
# Copyright (C) 2007  Eric C. Cooper <ecc@cmu.edu>
# Released under the GNU General Public License

export OCAMLMAKEFILE = /usr/share/ocamlmakefile/OCamlMakefile

export OCAMLFLAGS += -warn-error A

define PROJ_server
    SIDE_EFFECT = $(shell ./mkversion > version.ml)
    SOURCES = util.ml version.ml config.ml default_config.ml log.ml url.ml control_file.ml release.ml patch.ml pdiff.ml ifaddr.c internet.mli server.ml approx.ml
    INCDIRS = +pcre +sha +syslog +netsys +netstring +netcgi2 +nethttpd-for-netcgi2
    LIBS = unix pcre sha syslog netsys netstring netcgi nethttpd-for-netcgi2
    RESULT = approx
endef
export PROJ_server

define PROJ_gc
    SOURCES = util.ml version.ml config.ml default_config.ml log.ml url.ml control_file.ml release.ml gc.ml
    INCDIRS = +pcre +sha +syslog +netsys +netstring
    LIBS = unix pcre sha syslog netsys netstring
    RESULT = gc_approx
endef
export PROJ_gc

define PROJ_update
    SOURCES = util.ml version.ml config.ml default_config.ml log.ml url.ml control_file.ml release.ml patch.ml pdiff.ml update.ml
    INCDIRS = +pcre +sha +syslog +netsys +netstring
    LIBS = unix pcre sha syslog netsys netstring
    RESULT = update_approx
endef
export PROJ_update

ifndef SUBPROJS
    export SUBPROJS = server gc update
endif

all: native-code

export TRASH = version.ml

%:
	@$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=$@

=== tests/Makefile ===
# approx: proxy server for Debian archive files
# Copyright (C) 2007  Eric C. Cooper <ecc@cmu.edu>
# Released under the GNU General Public License

export OCAMLMAKEFILE = /usr/share/ocamlmakefile/OCamlMakefile

export OCAMLFLAGS += -warn-error A

export VPATH += ..

define PROJ_config
    SOURCES = util.ml config.ml config_test.ml
    INCDIRS = .. +pcre +sha
    LIBS = unix pcre sha
    RESULT = config_test
endef
export PROJ_config

define PROJ_control_file
    SOURCES = util.ml config.ml version.ml default_config.ml log.ml control_file.ml control_file_test.ml
    INCDIRS = .. +pcre +sha +syslog
    LIBS = unix pcre sha syslog
    RESULT = control_file_test
endef
export PROJ_control_file

define PROJ_ifaddr
    SOURCES = ifaddr.c internet.mli ifaddr_test.ml
    INCDIRS = ..
    LIBS = unix
    RESULT = ifaddr_test
endef
export PROJ_ifaddr

define PROJ_metadata
    SOURCES = util.ml config.ml version.ml default_config.ml log.ml control_file.ml release.ml metadata_test.ml
    INCDIRS = .. +pcre +sha +syslog
    LIBS = unix pcre sha syslog
    RESULT = metadata_test
endef
export PROJ_metadata

define PROJ_patch
    SOURCES = util.ml patch.ml patch_test.ml
    INCDIRS = .. +pcre +sha
    LIBS = unix pcre sha
    RESULT = patch_test
endef
export PROJ_patch

define PROJ_sha1
    SOURCES = util.ml sha1_test.ml
    INCDIRS = .. +pcre +sha
    LIBS = unix pcre sha
    RESULT = sha1_test
endef
export PROJ_sha1

ifndef SUBPROJS
    export SUBPROJS = config control_file ifaddr metadata patch sha1
endif

all: native-code

%:
	@$(MAKE) -f $(OCAMLMAKEFILE) subprojs SUBTARGET=$@

=== debian/changelog ===
approx (3.0.0) unstable; urgency=low

  * Support pdiffs (closes: #405535)
  * Create temp files in approx cache rather than TMPDIR (closes: #451768)
  * Added $offline parameter to control delivery of cached files
    when remote downloads fail (closes: #442801)

 -- Eric Cooper <ecc@cmu.edu>  Tue, 04 Dec 2007 12:24:16 -0500

approx (2.9.1) unstable; urgency=low

  * Make sure cron job doesn't fail if approx has been removed
    (closes: #404819)
  * Add Homepage field

 -- Eric Cooper <ecc@cmu.edu>  Wed, 03 Oct 2007 11:31:56 -0400

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: admin
 Priority: optional
 Maintainer: Eric Cooper <ecc@cmu.edu>
-Uploaders: Sylvain Le Gall <gildor@debian.org>
-Build-Depends: debhelper (>= 5.0), cdbs, ocamlmakefile, ocaml-nox (>= 3.09), ocaml-best-compilers, libnethttpd-ocaml-dev (>= 2.2), libpcre-ocaml-dev (>= 5.11), libsha-ocaml-dev (>= 1.3), libsyslog-ocaml-dev (>= 1.3)
+Uploaders: Sylvain Le Gall <gildor@debian.org>, Ralf Treinen <treinen@debian.org>
+XS-Dm-Upload-Allowed: yes
+Build-Depends: debhelper (>= 5.0), cdbs, ocamlmakefile, ocaml-nox (>= 3.10), ocaml-best-compilers, libnethttpd-ocaml-dev (>= 2.2.8), libpcre-ocaml-dev (>= 5.11), libsha-ocaml-dev (>= 1.3), libsyslog-ocaml-dev (>= 1.3)
 Standards-Version: 3.7.2
+Homepage: http://svn.debian.org/wsvn/pkg-ocaml-maint/trunk/projects/approx
 XS-Vcs-Svn: svn://svn.debian.org/svn/pkg-ocaml-maint/trunk/projects/approx
 
 Package: approx
@@ -31,5 +33,3 @@
  .
  Approx is intended to be robust, simple, and efficient.
  It is written in OCaml (Objective Caml).
- .
-  Homepage: http://svn.debian.org/wsvn/pkg-ocaml-maint/trunk/projects/approx/

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/class/ocaml.mk

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
    DEB_MAKE_BUILD_TARGET = native-code
    DEB_DH_GENCONTROL_ARGS += -VF:OCamlRun=""
else
    DEB_MAKE_BUILD_TARGET = byte-code
    DEB_DH_GENCONTROL_ARGS += -VF:OCamlRun="ocaml-base-nox-$(OCAML_ABI)"
endif

## approx 3.3.0~bpo40+2

=== Makefile ===
# approx: proxy server for Debian archive files
# Copyright (C) 2008  Eric C. Cooper <ecc@cmu.edu>
# Released under the GNU General Public License

OCAMLBUILD := ocamlbuild
OCAMLBUILD_OPTS := -classic-display

TARGET := native

ifeq ($(TARGET),byte)
    OCAMLBUILD_OPTS += -byte-plugin
endif

all:
	@set -e; for prog in approx gc update; do \
	    echo $(OCAMLBUILD) $(OCAMLBUILD_OPTS) $$prog.$(TARGET); \
	    $(OCAMLBUILD) $(OCAMLBUILD_OPTS) $$prog.$(TARGET); \
	    cp -pv _build/$$prog.$(TARGET) $$prog; \
	done
	@mv -v gc gc_approx
	@mv -v update update_approx

clean:
	$(OCAMLBUILD) $(OCAMLBUILD_OPTS) -clean
	rm -f approx gc_approx update_approx

.PHONY: tests

test_programs = $(wildcard tests/*.ml)

tests:
	@set -e; for test in $(test_programs:.ml=); do \
	    echo $(OCAMLBUILD) $(OCAMLBUILD_OPTS) $$test.$(TARGET); \
	    $(OCAMLBUILD) $(OCAMLBUILD_OPTS) $$test.$(TARGET); \
	done

=== debian/changelog ===
approx (3.3.0~bpo40+2) etch-backports; urgency=low

  * Update debian/control build-dependencies to use the versions
    in backports.org:
    . ocaml-nox (>= 3.10.0-13~bpo40+1)
    . ocaml-native-compilers (>= 3.10.1-1~bpo40+3)
    . libnethttpd-ocaml-dev (>= 2.2.9-1~bpo40+5)
    . libpcre-ocaml-dev (>= 5.12.2-3~bpo40+1)
    . libsha-ocaml-dev (>= 1.4-4~bpo40+1)
    . libsyslog-ocaml-dev (>= 1.3-6~bpo40+1)

 -- Micah Anderson <micah@debian.org>  Fri, 25 Jul 2008 13:53:48 -0600

approx (3.3.0~bpo40+1) etch-backports; urgency=low

  * backport testing version for etch
  * downgrade to debhelper 5, no changes
  * thanks to vagrant cascadian for the help!

 -- Micah Anderson <micah@debian.org>  Wed, 23 Jul 2008 22:54:32 +0000

approx (3.3.0) unstable; urgency=low

  * Allow empty host name in file URLs (closes: #479022)
  * Use unique temporary names to avoid race condition
    when opening cache files (closes: #488080)
  * Use hint files to avoid (but not eliminate) duplicate downloads
  * Remove unnecessary getpeername call in server loop

 -- Eric Cooper <ecc@cmu.edu>  Sat, 03 May 2008 16:43:25 -0400

approx (3.2.0) unstable; urgency=low

  * Listen on both IPv4 and IPv6 sockets when available
  * Add setsockopt IPV6_V6ONLY to allow both kinds of sockets to bind
    to the same port, as suggested by Julien Cristau <jcristau@debian.org>
  * Enable -custom for all bytecode executables, not just ones that
    directly use C stubs, to avoid missing DLLs from libpcre-ocaml, etc.
    at runtime (closes: #476367)

 -- Eric Cooper <ecc@cmu.edu>  Wed, 16 Apr 2008 21:49:01 -0400

approx (3.1.0) unstable; urgency=low

  * Prevent dh_strip from stripping custom bytecode executables
    (closes: #473707)
  * Change to debhelper v6 mode

 -- Eric Cooper <ecc@cmu.edu>  Wed, 02 Apr 2008 11:00:55 -0400

approx (3.1.0~rc2) experimental; urgency=low

  * Pass -byte-plugin flag to ocamlbuild when building bytecode
    (closes: #471665)

 -- Eric Cooper <ecc@cmu.edu>  Tue, 01 Apr 2008 14:49:03 -0400

approx (3.1.0~rc1) experimental; urgency=low

  * Added support for IPv6 and TCP wrappers
    - added build-dependency on libwrap0-dev
    - closes: #468058
  * Fixed mishandling of HTTP redirections
    - handle redirection status codes and location headers in approx.ml,
      following patch supplied by Håkon Stordahl <haastord@online.no>
    - remove curl --location option from Url.download but not Url.download_file
    - closes: #469580
  * Added transparent proxying for requests that should be passed through
    without caching (closes: #469616)
  * Perform server initializations like binding to port and dropping privileges
    before daemonizing, so that any failures will be noticed by the init script
    (closes: #465450)
  * Changed Patch module to use a single composite operator
    instead of a list, so Patch.apply is just function application
  * Updated Standards-Version, DM-Upload-Allowed and VCS-* in debian/control
  * Changed from ocamlmakefile to ocamlbuild
    - removed ocamlmakefile from Build-Depends
    - added _tags files and myocamlbuild.ml plugin
    - new, simpler Makefile
    - updated debian/rules to deal with .native and .byte targets
  * Improved documentation of the garbage collection algorithm in gc.ml
  * Changed debug_message and info_message to check corresponding
    config parameters ($debug, $verbose) so callers don't have to
  * Renamed config -> config_file and default_config -> config
  * Style changes (mostly whitespace-only)
    - use only spaces in indentation, no tabs
    - write lists like this: [1; 2; 3]
    - avoid single begin/end lines

 -- Eric Cooper <ecc@cmu.edu>  Thu, 13 Mar 2008 10:05:56 -0400

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Eric Cooper <ecc@cmu.edu>
 Uploaders: Sylvain Le Gall <gildor@debian.org>, Ralf Treinen <treinen@debian.org>
-XS-Dm-Upload-Allowed: yes
-Build-Depends: debhelper (>= 5.0), cdbs, ocamlmakefile, ocaml-nox (>= 3.10), ocaml-best-compilers, libnethttpd-ocaml-dev (>= 2.2.8), libpcre-ocaml-dev (>= 5.11), libsha-ocaml-dev (>= 1.3), libsyslog-ocaml-dev (>= 1.3)
-Standards-Version: 3.7.2
+DM-Upload-Allowed: yes
+Build-Depends: debhelper (>= 5.0), cdbs, ocaml-nox (>= 3.10.0-13~bpo40+1), ocaml-native-compilers (>= 3.10.1-1~bpo40+3) | ocaml-best-compilers, libnethttpd-ocaml-dev (>= 2.2.9-1~bpo40+5), libpcre-ocaml-dev (>= 5.12.2-3~bpo40+1), libsha-ocaml-dev (>= 1.4-4~bpo40+1), libsyslog-ocaml-dev (>= 1.3-6~bpo40+1), libwrap0-dev
+Standards-Version: 3.7.3
 Homepage: http://svn.debian.org/wsvn/pkg-ocaml-maint/trunk/projects/approx
-XS-Vcs-Svn: svn://svn.debian.org/svn/pkg-ocaml-maint/trunk/projects/approx
+Vcs-Svn: svn://svn.debian.org/svn/pkg-ocaml-maint/trunk/projects/approx/trunk
+Vcs-Browser: http://svn.debian.org/wsvn/pkg-ocaml-maint/trunk/projects/approx/trunk/
 
 Package: approx
 Architecture: any

## approx 3.3.0

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Eric Cooper <ecc@cmu.edu>
 Uploaders: Sylvain Le Gall <gildor@debian.org>, Ralf Treinen <treinen@debian.org>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 5.0), cdbs, ocaml-nox (>= 3.10.0-13~bpo40+1), ocaml-native-compilers (>= 3.10.1-1~bpo40+3) | ocaml-best-compilers, libnethttpd-ocaml-dev (>= 2.2.9-1~bpo40+5), libpcre-ocaml-dev (>= 5.12.2-3~bpo40+1), libsha-ocaml-dev (>= 1.4-4~bpo40+1), libsyslog-ocaml-dev (>= 1.3-6~bpo40+1), libwrap0-dev
+Build-Depends: debhelper (>= 6.0), cdbs, ocaml-nox (>= 3.10), ocaml-best-compilers, libnethttpd-ocaml-dev (>= 2.2.8), libpcre-ocaml-dev (>= 5.11), libsha-ocaml-dev (>= 1.3), libsyslog-ocaml-dev (>= 1.3), libwrap0-dev
 Standards-Version: 3.7.3
 Homepage: http://svn.debian.org/wsvn/pkg-ocaml-maint/trunk/projects/approx
 Vcs-Svn: svn://svn.debian.org/svn/pkg-ocaml-maint/trunk/projects/approx/trunk

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/class/ocaml.mk

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
    DEB_MAKE_BUILD_TARGET = TARGET=native
    DEB_DH_GENCONTROL_ARGS += -VF:OCamlRun=""
else
    DEB_MAKE_BUILD_TARGET = TARGET=byte
    DEB_DH_GENCONTROL_ARGS += -VF:OCamlRun="ocaml-base-nox-$(OCAML_ABI)"
    DEB_STRIP_EXCLUDE += usr/sbin
endif

## approx 3.5

=== Makefile ===
--- 
+++ 
@@ -11,18 +11,24 @@
     OCAMLBUILD_OPTS += -byte-plugin
 endif
 
+programs = gc update import
+
 all:
-	@set -e; for prog in approx gc update; do \
+	@set -e; for prog in approx $(programs); do \
 	    echo $(OCAMLBUILD) $(OCAMLBUILD_OPTS) $$prog.$(TARGET); \
 	    $(OCAMLBUILD) $(OCAMLBUILD_OPTS) $$prog.$(TARGET); \
 	    cp -pv _build/$$prog.$(TARGET) $$prog; \
 	done
-	@mv -v gc gc_approx
-	@mv -v update update_approx
+	@set -e; for prog in $(programs); do \
+	    mv -v $$prog approx-$$prog; \
+	done
 
 clean:
 	$(OCAMLBUILD) $(OCAMLBUILD_OPTS) -clean
-	rm -f approx gc_approx update_approx
+	rm -f approx $(patsubst %,approx-%,$(programs))
+
+extra-clean: clean
+	rm -f *~ \#*
 
 .PHONY: tests
 
@@ -33,3 +39,16 @@
 	    echo $(OCAMLBUILD) $(OCAMLBUILD_OPTS) $$test.$(TARGET); \
 	    $(OCAMLBUILD) $(OCAMLBUILD_OPTS) $$test.$(TARGET); \
 	done
+
+upstream-branch:
+	git-status | grep -q "^# On branch upstream"
+
+release: upstream-branch extra-clean
+	@set -e; \
+	version=$$(sed -n 's/^.*number = "\(.*\)".*$$/\1/p' version.ml); \
+	echo Tagging upstream/$$version; \
+	git tag -f -m "upstream version $$version" upstream/$$version; \
+	tarball=../approx_$$version.orig.tar.gz; \
+	echo Creating $$tarball; \
+	package=approx-$$version; \
+	tar czf $$tarball --transform "s:^\./:$$package/:" --exclude=.git .

## approx 4.0

=== Makefile ===
# approx: proxy server for Debian archive files
# Copyright (C) 2009  Eric C. Cooper <ecc@cmu.edu>
# Released under the GNU General Public License

OCAMLBUILD := ocamlbuild
OCAMLBUILD_OPTS := -classic-display

TARGET := native

ifeq ($(TARGET),byte)
    OCAMLBUILD_OPTS += -byte-plugin
endif

programs = approx approx-gc approx-update approx-import

all: $(programs)

approx:
	$(OCAMLBUILD) $(OCAMLBUILD_OPTS) approx.$(TARGET)
	cp -p _build/approx.$(TARGET) $@

approx-%:
	$(OCAMLBUILD) $(OCAMLBUILD_OPTS) $(@:approx-%=%).$(TARGET)
	cp -pv _build/$(@:approx-%=%).$(TARGET) $@

$(programs): $(wildcard *.ml*)

clean:
	$(OCAMLBUILD) $(OCAMLBUILD_OPTS) -clean
	rm -f $(programs)

.PHONY: tests

tests: $(subst .ml,,$(wildcard tests/*.ml))

%_test:
	$(OCAMLBUILD) $(OCAMLBUILD_OPTS) $@.$(TARGET)

version := $(shell sed -n 's/^let version = "\(.*\)"$$/\1/p' config.ml)
tarball := approx_$(version).orig.tar.gz
package := approx-$(version)
excludes := $(tarball) .git _build "*~" "\#*"

tarball:
	tar -czf $(tarball) $(excludes:%=--exclude=%) \
	    --transform "s:^\./:$(package)/:" .

## approx 4.3

=== debian/changelog ===
approx (4.3-1) unstable; urgency=low

  * New upstream version
  * Use TMPDIR if accessible, otherwise use /tmp (closes: #573593)
  * Catch correct exception when Release file is missing md5sum section
    (closes: #573039)
  * Add explanation for openbsd-inetd rate-limiting (closes: #581220)
  * Avoid symlinks when traversing directories (closes: #582294)

 -- Eric Cooper <ecc@cmu.edu>  Sat, 12 Jun 2010 10:35:25 -0400

approx (4.2-1) unstable; urgency=low

  * New upstream version
  * Improve handling of invalid index files
  * Recognize compressed tarballs from 3.0 (quilt) format
  * Use dh-ocaml (>= 0.9) and simplify debian/rules
  * Update build-deps
  * Drop lsb-base dependency since approx no longer needs an init script
  * Update Standards-Version to 3.8.4
  * Suggest libconfig-model-approx-perl (closes: #554388)
  * Change to 3.0 (quilt) format

 -- Eric Cooper <ecc@cmu.edu>  Sun, 14 Feb 2010 16:52:00 -0500

approx (4.1-1) unstable; urgency=low

  * New upstream version
  * Ignore epoch when comparing versions for importing
    (closes: #518763, #545424)
  * Deliver files properly in offline mode (closes: #524960)
  * Support udebs
    - patch from Matthew Palmer <mpalmer@debian.org>
    - closes: #527188
  * Support https in URLs
    - patch from Andres Salomon <dilinger@collabora.co.uk>
    - closes: #531218
  * Add Czech debconf translation (closes: #537107)
  * Fix update-inetd call in postrm script
  * Update Standards-Version to 3.8.3
  * Add FAQ file

 -- Eric Cooper <ecc@cmu.edu>  Mon, 07 Sep 2009 18:16:20 -0400

approx (4.0-3) unstable; urgency=low

  * Add Japanese debconf translation (closes: #524624)

 -- Eric Cooper <ecc@cmu.edu>  Thu, 11 Jun 2009 15:53:01 -0400

approx (4.0-2) unstable; urgency=low

  * Debconf templates and debian/control reviewed by the debian-l10n-english
    team (closes: #522644)
  * Debconf translation updates:
    - Georgian (closes: #523427)
    - Italian (closes: #523489)
    - Swedish (closes: #523836)
    - Portuguese (closes: #524110)
    - German (closes: #524398)
    - Galician (closes: #524401)
    - Spanish (closes: #525271)
    - French (closes: #525519)
    - Russian (closes: #525521)
    - Finnish (closes: #526370)
  * Thanks to Christian Perrier for coordinating the above
    reviews and translations

 -- Eric Cooper <ecc@cmu.edu>  Mon, 01 Jun 2009 16:14:51 -0400

approx (4.0-1) unstable; urgency=low

  * New upstream version
  * Change approx to run under inetd (closes: #517217, #479493)
  * Update packaging for OCaml 3.11 (closes: #518727)
  * Revert to dropping privileges in gc, update, and import
    (closes: #510761)
  * approx-import: use MD5 checksums instead of names and versions
    (closes: #518753, #518763)
  * approx-import: print status of each file when importing in verbose mode
    (closes: #518761)

 -- Eric Cooper <ecc@cmu.edu>  Tue, 10 Mar 2009 13:37:00 -0400

approx (3.5-1) unstable; urgency=low

  * New upstream version
  * Handle unreadable directories like lost+found more robustly
    (closes: #488115)
  * Decompress files in /tmp so gc can be used on a full filesystem
    (closes: #490028)
  * Handle multiple blank lines between paragraphs in control files
    (closes: #501628)
  * Use "Pragma: no-cache" in case approx is behind a caching proxy
    (closes: #502405)
  * Check for correct user and group ID instead of dropping privileges
    in auxiliary programs like gc and update; use "su" in cron jobs
  * Create directories when importing files into the cache

 -- Eric Cooper <ecc@cmu.edu>  Wed, 19 Nov 2008 20:42:00 -0500

approx (3.4-1) unstable; urgency=low

  * Change to non-native Debian package
  * Update VCS info in debian/control to reflect change from svn to git
  * Fix race condition when creating directory for cache file
    (closes: #501406)
  * Add approx-import program to import local .debs into approx cache
    (closes: #488096)
  * Renamed auxiliary programs approx-gc and approx-update for consistency
  * Thanks to Stéphane Glondu for svn to git migration

 -- Eric Cooper <ecc@cmu.edu>  Thu, 23 Oct 2008 21:16:00 -0400

=== debian/control ===
Source: approx
Section: admin
Priority: optional
Maintainer: Eric Cooper <ecc@cmu.edu>
Uploaders: Sylvain Le Gall <gildor@debian.org>, Ralf Treinen <treinen@debian.org>
DM-Upload-Allowed: yes
Build-Depends:
 ocaml-nox (>= 3.11),
 libnethttpd-ocaml-dev (>= 2.2.9),
 libpcre-ocaml-dev (>= 6.0),
 libsha-ocaml-dev (>= 1.6),
 libsyslog-ocaml-dev (>= 1.4),
 debhelper (>= 7.0),
 cdbs (>= 0.4.62),,
 dh-ocaml (>= 0.9)
Standards-Version: 3.8.4
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/approx.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/approx.git
Homepage: http://git.debian.org/?p=pkg-ocaml-maint/packages/approx.git

Package: approx
Architecture: any
Depends:
 ${ocaml:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
 adduser,
 bzip2,
 curl,
 openbsd-inetd | inet-superserver,
 update-inetd
Suggests: libconfig-model-approx-perl
Description: caching proxy server for Debian archive files
 Approx is an HTTP-based proxy server for Debian-style package archives.
 It fetches files from remote repositories on demand,
 and caches them for local use.
 .
 Approx saves time and network bandwidth if you need to install or
 upgrade .deb packages for a number of machines on a local network.
 Each package is downloaded from a remote site only once,
 regardless of how many local clients install it.
 The approx cache typically requires a few gigabytes of disk space.
 .
 Approx also simplifies the administration of client machines:
 repository locations need only be changed in approx's configuration file,
 not in every client's /etc/apt/sources.list file.
 .
 Approx can be used as a replacement for apt-proxy,
 with no need to modify clients' /etc/apt/sources.list files,
 or as an alternative to apt-cacher.
